#include <stdio.h>
#include <stdlib.h>

#define C_WALL '#'
#define C_FREE '.'

#define ARGINT(n) atoi(argv[n])

int randint(int from, int to)
{
	return from + rand() % (to-from+1);
}

/*
 * K, L = the whole area
 * M, N = rectange to erase
 * density = 0..1000, probability of placing a wall
 */
void gen(int min_KL, int max_KL, int min_MN, int max_MN, int density)
{
	int K = randint(min_KL, max_KL);
	int L = randint(min_KL, max_KL);
	int M = randint(min_MN, max_MN);
	int N = randint(min_MN, max_MN);

	printf("%d %d %d %d\n", K, L, M, N);
	int i,j;
	for(i=0; i<K; i++)
	{
		for(j=0; j<L; j++)
		{
			char out = (randint(0, 1000) < density) ? C_WALL : C_FREE;
			printf("%c", out);
		}
		printf("\n");
	}
}

int main(int argc, char *argv[])
{
	if(argc != 7)
	{
		fprintf(stderr, "usage: %s min_KL max_KL min_MN max_MN density seed\n", argv[0]);
		exit(1);
	}

	srand(strtoull(argv[6], NULL, 16) & 0x7fffffff);
	gen(ARGINT(1), ARGINT(2), ARGINT(3), ARGINT(4), ARGINT(5));

	return 0;
}
