#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXKL 1000
#define MAXMN 1000
#define MAXF (MAXKL*MAXKL)

int K, L, M, N;
char map[MAXKL+2][MAXKL+2];
int room[MAXKL+2][MAXKL+2];
int queue[MAXF][2];
int inside[MAXF+1];
int nrooms;

#if 1
#define ASSERT(_x) do { if (!(_x)) { fprintf(stderr, "Assertion failure at line %d\n", __LINE__); exit(99); } } while (0)
#else
#define ASSERT(_x) do { } while (0)
#endif

void chew(void)
{
	int cc = scanf("%d%d%d%d", &K, &L, &M, &N);
	ASSERT(cc = 4);
	ASSERT(K >= 1 && K <= MAXKL);
	ASSERT(L >= 1 && L <= MAXKL);
	ASSERT(M >= 1 && M <= MAXMN);
	ASSERT(N >= 1 && N <= MAXMN);

	int c = getchar();
	ASSERT(c == '\n');

	for (int i=1; i<=K; i++) {
		for (int j=1; j<=L; j++) {
			c = getchar();
			ASSERT(c == '.' || c == '#');
			map[i][j] = c;
		}
		c = getchar();
		ASSERT(c == '\n');
	}
	c = getchar();
	ASSERT(c < 0);
}

void bfs(void)
{
	for (int i=1; i<=K; i++)
		for (int j=1; j<=L; j++)
			if (!room[i][j] && map[i][j] == '.') {
#define C(a,b) if (!room[a][b] && map[a][b] == '.') { room[a][b] = nrooms; queue[w][0] = a; queue[w][1] = b; w++; }
				nrooms++;
				int r = 0;
				int w = 0;
				C(i, j);
				while (r < w) {
					int x = queue[r][0];
					int y = queue[r][1];
					r++;
					C(x-1, y);
					C(x+1, y);
					C(x, y-1);
					C(x, y+1);
				}
#undef C
			}
	// printf("nrooms = %d\n", nrooms);
}

void solve(void)
{
	int areas = 0;
	int amax = 0;
	int round = 0;

	int KK = K+2, LL = L+2;
	int MM = M+2, NN = N+2;

	for (int i=0; i<=KK-MM; i++)
		for (int j=0; j<=LL-NN; j++) {
			round++;
			areas = 0;
			for (int k=i; k<i+MM; k++)
				for (int l=j; l<j+NN; l++) {
					if ((k == i || k == i+MM-1) && (l == j || l == j+NN-1))
						continue;
					if (room[k][l] && inside[room[k][l]] != round) {
						inside[room[k][l]] = round;
						areas++;
					}
				}
			if (areas > amax)
				amax = areas;
		}

	printf("%d\n", amax);
}

int main(void)
{
	chew();
	bfs();
	solve();
	return 0;
}
