#include <stdio.h>
#include <stdlib.h>

#define MAXKL 1000
#define MAXMN 1000
#define MAXF (MAXKL*MAXKL)

static int R, C, M, N;
static char mapa[MAXKL+2][MAXKL+2];
static int mistnost[MAXKL+2][MAXKL+2];
static int zasobnik[MAXF][2];
static int velikost_zasobniku;
static int prekryv[MAXF+1];
static int pocet_mistnosti;

static void
nacti_vstup(void)
{
  int i;
  scanf("%d%d%d%d", &R, &C, &M, &N);

  for (i = 1; i <= R; i++)
    scanf ("%s", mapa[i] + 1);
}

static void
prohod (char *x, char *y)
{
  char t = *x;
  *x = *y;
  *y = t;
}

static void
transponuj (void)
{
  int i, j;
  int RC = R < C ? R : C;

  for (i = 0; i <= R + 1; i++)
    for (j = 0; j <= C + 1; j++)
      if (i > RC + 1 || j > RC + 1 || i < j)
	prohod (&mapa[i][j], &mapa[j][i]);

  int t = R;
  R = C;
  C = t;

  t = M;
  M = N;
  N = t;
}

static void
zkus_jit (int x, int y)
{
  if (!mistnost[x][y] && mapa[x][y] == '.')
    {
      mistnost[x][y] = pocet_mistnosti;
      zasobnik[velikost_zasobniku][0] = x;
      zasobnik[velikost_zasobniku][1] = y;
      velikost_zasobniku++;
    }
}

static void
najdi_mistnosti (void)
{
  int i, j;
  
  for (i = 1; i <= R; i++)
    for (j = 1; j <= C; j++)
      if (!mistnost[i][j] && mapa[i][j] == '.')
	{
	  pocet_mistnosti++;

	  zkus_jit (i, j);
	  while (velikost_zasobniku > 0)
	    {
	      velikost_zasobniku--;
	      int x = zasobnik[velikost_zasobniku][0];
	      int y = zasobnik[velikost_zasobniku][1];
	      zkus_jit (x - 1, y);
	      zkus_jit (x + 1, y);
	      zkus_jit (x, y - 1);
	      zkus_jit (x, y + 1);
	    }
	}
}

static int akt_mistnosti, max_mistnosti;

static void
zvetsi_prekryv (int i, int j)
{
  if (mistnost[i][j]
      && ++prekryv[mistnost[i][j]] == 1)
    akt_mistnosti++;
}

static void
zmensi_prekryv (int i, int j)
{
  if (mistnost[i][j]
      && --prekryv[mistnost[i][j]] == 0)
    akt_mistnosti--;
}

static void
vyzkousej_radek (int r)
{
  int j, k;

  for (j = 1; j <= N; j++)
    for (k = -1; k <= M; k++)
      zvetsi_prekryv (r + k, j);
  for (k = 0; k < M; k++)
    zvetsi_prekryv (r + k, N + 1);
  if (akt_mistnosti > max_mistnosti)
    max_mistnosti = akt_mistnosti;

  for (j = 1; j <= C - N; j++)
    {
      for (k = 0; k < M; k++)
	{
	  zmensi_prekryv (r + k, j - 1);
	  zvetsi_prekryv (r + k, j + N + 1);
	}
      zmensi_prekryv (r - 1, j);
      zmensi_prekryv (r + M, j);
      zvetsi_prekryv (r - 1, j + N);
      zvetsi_prekryv (r + M, j + N);

      if (akt_mistnosti > max_mistnosti)
	max_mistnosti = akt_mistnosti;
    }
  for (j = C - N + 1; j <= C; j++)
    for (k = -1; k <= M; k++)
      zmensi_prekryv (r + k, j);
  for (k = 0; k < M; k++)
    zmensi_prekryv (r + k, C - N);
}

static void
vyzkousej_diry (void)
{
  int i;

  for (i = 1; i <= R - M + 1; i++)
    vyzkousej_radek (i);
}

int main(void)
{
  nacti_vstup();
  if (M > N)
    transponuj ();

  najdi_mistnosti();
  vyzkousej_diry ();
  printf("%d\n", max_mistnosti);
  return 0;
}
